/*
 * "Copyright (c) 1999 by Brent N. Chun and The Regents of the University 
 * of California.  All rights reserved."
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice and the following
 * two paragraphs appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */
#ifndef __HASH_H
#define __HASH_H

/* Programmer manages storage for key, val */
typedef struct _hash_table_entry {
    void                        *key;
    int                         klen;
    void                        *val;
    int                         vlen;
    struct _hash_table_entry    *prev;
    struct _hash_table_entry    *next;
} hash_table_entry;

typedef struct _hash_table {
    int                 size;
    hash_table_entry    **chains;
} hash_table;

void hash_table_create(hash_table **t, int size);
void hash_table_destroy(hash_table *t);
int  hash_table_insert(hash_table *t, void *key, int klen, void *val, int vlen);
int  hash_table_delete(hash_table *t, void *key, int klen);
int  hash_table_search(hash_table *t, void *key, int klen, void **val, int *vlen);

#endif /* __HASH_H */ 
