#ifndef __TREE_H
#define __TREE_H

typedef struct {
    int  nhosts;
    char **ips;
    int  *parents;
    int  fanout;
} tree;

int  tree_create(tree **t, int nhosts, char **ips, int fanout);
int  tree_create_from_buf(tree **t, void *buf, int buf_len);
void *tree_malloc_buf(tree *t, int *buf_len);
void tree_destroy(tree *t);

int  tree_parent(tree *t, int node);
int  tree_child(tree *t, int node, int child_num);
int  tree_num_children(tree *t, int node);
int  tree_node(tree *t, char *ip);
int  tree_node_nr(tree *t, char *host);

#define ROOT  0

#endif /* __TREE_H */

